c imp_dims, imp_control, imp_gen_io has to be careful, some variables have to initialized before use. 

      subroutine h_init()
     
      use h_imp_dims, only: i1_gl, i2_gl,ju1_gl,j2_gl, ilo,ihi,julo,jhi,
     &k1,k2,i1,i2, ju1,j2, ilat, ilong, ivert,itloop ,
     &num_emiss, emiss_timpyr,num_qjs,num_qks,num_species,num_molefrac,
     &loc_proc, pr_diag, num_sad,lbssad_timpyr, num_qhs,num_qaqs, 
     & num_qaqqs, num_active, num_chem,num_qjo       
     
      use h_imp_control, only: imgas_num,do_clear_sky,nymd,nhms,
     &mw,emiss_map,initrogen_num,ioxygen_num, num_time_steps, chem_opt, 
     &phot_opt,do_wetchem, ico_num, rxnr_adjust_map, iisoprene_num,
     & ipropene_num, synoz_threshold, cldlap_opt,ino_num,ih2o_num,
     & io3_num, s_kbase, s_dh, pt,  do_synoz, isynoz_num,
     & sad_opt,ihno3_num 
      
      use h_imp_gen_io, only: pr_sulf_src,qj_var_name,
     &qj_infile_name,aqua_infile_name, chem_infile_name,
     & metdata_name_org, metdata_name_model, pr_qj_o3_o1d, 
     & pr_qj_opt_depth, pr_surf_emiss, aop2d_infile_name,
     & lookup_infile_name 
      
      use h_setkin_par
      
      use h_setkin_mw, only: mw_data
!Guangxing Lin
      use ppgrid,     only: pver, pcols
      use spmd_utils, only: iam
      use hycoef, only: ps0
      use h_setkin_synspc, only: ISYNOZ
      
      implicit none
      
      










      
               
c ########################  imp_dims

c static    
      num_emiss =  26 ! from in_out/imp_namelist.F:1899  if (emiss_map(ic) > 0) num_emiss = num_emiss + 1
      emiss_timpyr = 1 !supposed to be read in from namelist, will not be used when using CAM5 emission.      
c   num_qjs = 1
c      num_qks = 8 
      pr_diag = .FALSE.
      
      
c dynamic , depend on the decomposition
      loc_proc = iam 
      
      i1    =  1
      i1_gl =  1
      ilo   =  1
      
      i2    =  1
      i2_gl =  1
      ihi   =  1
      
      ju1   =  1
      julo  =  1
      ju1_gl=  1
      
!      j2    =  1
!      j2_gl =  1
!      jhi   =  1
      
      k1    =  1
      k2    = pver 
      
!      ilat = i2 - i1 + 1   ! number of latitudes
      ilong= i2 - i1 + 1   ! number of longitudes
      ivert= k2 - k1 + 1  ! number of vertical layers
!      itloop = ilat * ilong * ivert
      
c dynamic, from other head file     
      num_species  = NSP !42, originall this is read in from namelist, I just set it to NSP from sekin_par.h
      num_molefrac = NMF ! from setkin_par.h

      num_sad =1
      lbssad_timpyr=12
    
c       -------------------
c       inum's in namelist:
c       -------------------

        io3_num       = IO3

c       -----------------------
c       inum's not in namelist:
c       -----------------------

c        ibrono2_num   = IBRONO2
c        ich4_num      = ICH4
c        in2o_num      = IN2O
c        idehyd_num    = IDEHYD
c        ih2o2_num     = IH2O2
c        ih2oaircr_num = IH2OAIR
c        ihcl_num      = IHCl
c        imgas_num     = IMGAS
c        initrogen_num = INITROGEN
c        ioxygen_num   = IOXYGEN

        ihno3_num     = IHNO3
        num_active    = NACT
        num_chem      = NCHEM
        num_molefrac  = NMF
        num_qjs       = NUM_J
        num_qjo       = NUM_J
        num_qks       = NUM_K
        num_qhs       = NUM_H
        num_qaqs      = NUM_AQ
        num_qaqqs     = NUM_AQQ
    
cc######################## end imp_dims

















c ########################  imp_control
c NEED TO update at each step !!!!!!!!!!!!!!!!!!
!       nhms = 20000           ! current hour/min/sec   (HHMMSS)
!       nymd = 970701           ! current year/month/day (YYMMDD)
!       num_time_steps = 0  !number of current time steps, used to determine wheteher to call aqua phase reaction.
       

c static
      imgas_num      = IMGAS  ! from setkin_par.h, index for gas density in #/cm^3
      initrogen_num  = INITROGEN
      ioxygen_num    = IOXYGEN
      ih2o_num      = IH2O
      isynoz_num =ISYNOZ
      
      do_clear_sky      = .FALSE.    ! for gas and aqueous phase sulf chemistry

       do_synoz = .true. 
c      print*, 'mw_data=',mw_data(1:NSP)
      
      mw(1:NSP) = mw_data(1:NSP) ! from setkin_mw.h
     
c from *.in file, will not be used when using CAM5 emission
      emiss_map(1)       = 2
      emiss_map(2)       = 3
      emiss_map(3)       = 4
      emiss_map(4)            = 91 !for isoprene 
      emiss_map(5)            = -1
      emiss_map(6)            = -1
      emiss_map(7)            = 43 +21
      emiss_map(8)            = 55 +21
      emiss_map(9)            = 66 +21
      emiss_map(10)           = 68 +21
      emiss_map(11)           = 58 +21
      emiss_map(12)           = 59 +21
      emiss_map(13)           = 60 +21
      emiss_map(14)           = 63 +21
      emiss_map(15)           = 62 +21
      emiss_map(16)           = 65 +21
      emiss_map(17)           = 67 +21
      emiss_map(18)           = 61 +21
      emiss_map(19)           = 71 +21
      emiss_map(20)           = 72 +21
      emiss_map(21)           = 73 +21
      emiss_map(22)           = 69 +21
      emiss_map(23)           = 111 +21
      emiss_map(24)           = 107 +21
      emiss_map(25)           = 108 +21
      emiss_map(26)           = 93  +21

c Guangxing Lin
      chem_opt = 9
      phot_opt = 6
      sad_opt = 3
      do_wetchem = .FALSE.
      rxnr_adjust_map = 0.d0    ! not used in the current IMPACT
      ico_num= ICO ! from setkin_par
      iisoprene_num = IC5H8 !from setkin_par
      ipropene_num= IC3H6 !from setkin_par
      ino_num     = INO ! from setkin_par 

      synoz_threshold = 150.0d-09 ! from .in file 
      cldlap_opt =2 ! from .in file
      s_kbase = 1.0d-2
c      s_dh = 79.d0
      s_dh = 42.d0


      pt = ps0*1.0d-2 ! hPa in IMPACT



c ########################  imp_gen_io
      pr_sulf_src     = .TRUE. ! should sulfur budgets    also be written to periodic
           
      qj_var_name     = 'qj'         ! NetCDF qj            variable   name
      qj_infile_name  = '/glade/work/jialeiz/input_SOA/TUVGRID2' 
      aqua_infile_name       = 'seasalt.75RH' ! NOT used. if used, should in Do_So2toPar_Rates
        
      chem_infile_name        = 
     &'/glade/work/jialeiz/input_SOA/
     &REACTION2018_test4.asc' !aqsoa_elvoc_1.asc'
       
      metdata_name_org = 'DAO'
      metdata_name_model ='GS'
      pr_qj_opt_depth = .FALSE.
      pr_qj_o3_o1d = .FALSE.
      pr_surf_emiss = .TRUE.
      
      aop2d_infile_name       = 'aop_4x5.nc' ! from .in file

      lookup_infile_name = '/glade/work/jialeiz/input_SOA/TUVGRID2' ! from .in file 
       
      call Setup_Syn_Spc ( )

      end subroutine

c-----------------------------------------------------------------------------
c
c ROUTINE
c   Setup_Syn_Spc
c
c DESCRIPTION
c   This routine sets up the synthetic species info.
c
c ARGUMENTS
c   None
c
c-----------------------------------------------------------------------------

      subroutine Setup_Syn_Spc ( )

      use h_imp_dims
      use h_imp_control
      use h_setkin_synspc

      implicit none

!#     include "imp_dims.h"
!#     include "imp_control.h"
!#     include "setkin_synspc.h"


c     ----------------------
c     Variable declarations.
c     ----------------------

         integer :: ii


c     ----------------
c     Begin Execution.
c     ----------------

      do_synoz   = .false.
      do_nodoz   = .false.

      isynoz_num = 0

      num_nox    = 0
      num_noy    = 0

      nox_map(:) = 0
      noy_map(:) = 0

c ********************************************
c ** Begin of modifications by Luis Olcese, UM
c ** From chemistry version
cc     ==================
c      if (chem_opt == 2) then
cc     ==================

c        if (USE_SYNOZ) then

c          do_synoz   = .true.

c          isynoz_num = ISYNOZ

c          if (USE_NODOZ) then

c            do_nodoz = .true.

c            NOXLOOP: do ii = 1, MAXNODOZ_ELEM

c              if (NOX_ELEM_MAP(ii) /= 0) then

c                num_nox = num_nox + 1

c                nox_map(ii) = NOX_ELEM_MAP(ii)

c              else

c                exit NOXLOOP

c              end if

c            end do NOXLOOP

c            NOYLOOP: do ii = 1, MAXNODOZ_ELEM
c              if (NOY_ELEM_MAP(ii) /= 0) then

c                num_noy = num_noy + 1

c                noy_map(ii) = NOY_ELEM_MAP(ii)

c              else

c                exit NOYLOOP

c              end if

c            end do NOYLOOP

c          end if

c        end if

cc     =======================
c      else if (chem_opt == 5) then
cc     =======================

c        do_synoz   = .true.

c        isynoz_num = 1

c        if (num_species == 2) then
c          do_nodoz = .true.

c          ihno3_num = 2

c        end if

cc     ======
c      end if
cc     ======

      if (chem_opt == 5) then

        do_synoz   = .true.

        isynoz_num = 1

      else if (chem_opt == 2 .or. chem_opt == 7 .or.
     &         chem_opt == 9) then
        if (USE_SYNOZ) then

          do_synoz   = .true.

          isynoz_num = ISYNOZ

          if (USE_NODOZ) then

            do_nodoz = .true.

            NOXLOOP: do ii = 1, MAXNODOZ_ELEM

              if (NOX_ELEM_MAP(ii) /= 0) then

                num_nox = num_nox + 1

                nox_map(ii) = NOX_ELEM_MAP(ii)

              else

                exit NOXLOOP

              end if

            end do NOXLOOP

      NOYLOOP: do ii = 1, MAXNODOZ_ELEM

              if (NOY_ELEM_MAP(ii) /= 0) then

                num_noy = num_noy + 1

                noy_map(ii) = NOY_ELEM_MAP(ii)

              else

                exit NOYLOOP

              end if

            end do NOYLOOP

          end if

        end if

      end if
c ** End of modifications by Luis Olcese, UM
c ********************************************


      return

      end 
