       module h_simpchem_cmq
       implicit none
       public 
c     ----------
c     Parameter
c     ----------

      integer,parameter ::
     & nrat =21, !# of chemical reaction rates including photolysis rates
     & ncoe =4  !# of coefficients to calculate reaction rates 

      real*8, parameter ::
     & verr = 1.d-3  ! Relative error between two iterations

      integer, parameter ::
     & iO3_simp = 1,
     & iOH_simp = 2,
     & iNO2_simp = 3,
     & iNO_simp = 4,
     & iHNO3_simp = 5

      integer, parameter ::
     & iO3_hv = 1,
     & iNO2_hv = 2,
     & iHNO3_hv = 3,
     & iH2O2_hv = 11,  !Guangxing Lin
     & iO3P3_hv = 5,
     & iNO3P3_hv = 6,
     & iNO3O2_hv = 7,
     & iN2O5_hv = 8,
     & iN2O5P3_hv = 9,
     & iHCHO_hv=10,
     & iHCHOH2_hv=11

c     ----------
c     Comms
c     ----------

      integer :: nhvintv 
      real*8 ::
     & thvintv      

c      common/BASIC1/ nhvintv  
c      common/BASIC2/ thvintv

c *** arrays used in tuv_lookup.F. Look up table variables
      integer :: ihv, nhv(22)
      
c      common/IMATRIX/ ihv,nhv(22)

      real*8 :: jparam(22), jval(56)
      real*8 :: hvmat(22,40), hvmatb(22), jarray(80,510,56)

c      common/RMATRIX/ hvmat(22,40), hvmatb(22),jarray(80,510,56),
c     & jparam(22), jval(56)

      end module h_simpchem_cmq

